/* ========================================
 * http://www.microchip.com/forums/m577584.aspx
 *
 * ========================================
*/

#include <FastSqrt.h>








//=============================================================
//http://www.microchip.com/forums/m577584.aspx
//=============================================================

uint16_t fsqrt_32bit_B(uint32_t val) // <206 tics
{
    uint32_t bit;
    uint32_t trial;
    uint32_t result = 0;
    
    for ( bit = 0x40000000; bit>0; bit = bit>>2 )
    {
        trial = result + bit;
        result >>= 1;
        if ( trial <= val )
        {
            result += bit;
            val    -= trial;
        }
    }
    
    return (uint16_t) result;
}

//=============================================================
// 32-bit input loop unfolded // <145 tick
//=============================================================

uint16_t fsqrt_32bit_B1(uint32_t value) // <193 tics
{
    uint32_t bit;
    uint32_t trial;
    uint32_t result = 0;
    
    
    //0:
        bit = 0x40000000;
        trial = result + bit;
        result >>= 1;
        if ( trial <= value ) {result += bit;  value  -= trial;}
    //1:
        //bit = 0x10000000;
        bit >>= 2;
        trial = result + bit;
        result >>= 1;
        if ( trial <= value ) {result += bit;  value  -= trial;}
    //2:
        //bit = 0x4000000;
        bit >>= 2;
        trial = result + bit;
        result >>= 1;
        if ( trial <= value ) {result += bit;  value  -= trial;}
    //3:
        //bit = 0x1000000;
        bit >>= 2;
        trial = result + bit;
        result >>= 1;
        if ( trial <= value ) {result += bit;  value  -= trial;}
    //4:
        //bit = 0x400000;
        bit >>= 2;
        trial = result + bit;
        result >>= 1;
        if ( trial <= value ) {result += bit;  value  -= trial;}
    //5:
        //bit = 0x100000;
        bit >>= 2;
        trial = result + bit;
        result >>= 1;
        if ( trial <= value ) {result += bit;  value  -= trial;}
    //6:
        //bit = 0x40000;
        bit >>= 2;
        trial = result + bit;
        result >>= 1;
        if ( trial <= value ) {result += bit;  value  -= trial;}
    //7:
        //bit = 0x10000;
        bit >>= 2;
        trial = result + bit;
        result >>= 1;
        if ( trial <= value ) {result += bit;  value  -= trial;}
    //8:
        //bit = 0x4000;
        bit >>= 2;
        trial = result + bit;
        result >>= 1;
        if ( trial <= value ) {result += bit;  value  -= trial;}
    //9:
        //bit = 0x1000;
        bit >>= 2;
        trial = result + bit;
        result >>= 1;
        if ( trial <= value ) {result += bit;  value  -= trial;}
    //10:
        //bit = 0x400;
        bit >>= 2;
        trial = result + bit;
        result >>= 1;
        if ( trial <= value ) {result += bit;  value  -= trial;}
    //11:
        //bit = 0x100;
        bit >>= 2;
        trial = result + bit;
        result >>= 1;
        if ( trial <= value ) {result += bit;  value  -= trial;}
    //12:
        //bit = 0x40;
        bit >>= 2;
        trial = result + bit;
        result >>= 1;
        if ( trial <= value ) {result += bit;  value  -= trial;}
    //13:
        //bit = 0x10;
        bit >>= 2;
        trial = result + bit;
        result >>= 1;
        if ( trial <= value ) {result += bit;  value  -= trial;}
    //14:
        //bit = 0x4;
        bit >>= 2;
        trial = result + bit;
        result >>= 1;
        if ( trial <= value ) {result += bit;  value  -= trial;}
    //15:
        //bit = 0x1;
        bit >>= 2;
        trial = result + bit;
        result >>= 1;
        if ( trial <= value ) {result += bit;  value  -= trial;}

        
    return (uint16_t) result;
}




/* [] END OF FILE */
